/* sbrktest.c */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main (void)
    {
    char buf[256], *p;
    int i, n, f;

    f = 0;
    for (;;)
        {
        n = (int)sbrk (0);
        (void)printf ("sbrk = %d\n", n);
        n = (int)ulimit (3, 0);
        (void)printf ("ulimit (3, 0) = %d\n", n);
        (void)printf ("? ");
        if (fgets (buf, sizeof (buf), stdin) == NULL)
            return (0);
        p = strchr (buf, '\n');
        if (p != NULL) *p = 0;
        if (buf[0] == 'q')
            return (0);
        if (buf[0] == 'f')
            {
            f = !f;
            (void)printf ("fill = %s\n", (f ? "on" : "off"));
            continue;
            }
        i = atoi (buf);
        p = sbrk (i);
        if ((int)p == -1)
            (void)printf ("error\n");
        else
            {
            (void)printf ("ok.\n");
            if (i > 0 && f)
                (void)memset (p, '*', i);
            }
        }
    }
